/* client.c */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <errno.h>

#if defined(__linux__)
#include <unistd.h>
#endif

#include "conn.h"

static conn_t con;

static void cleanup(void)
{
	conn_close(&con);
}

int main(int argc, char ** argv)
{
	long host = (127 << 24) + (0 << 16) + (0 << 8) + (1 << 0);
	struct timeval t;
	int rc;
	char sbuf[128];
	char rbuf[128];
	short port;

	atexit(cleanup);

	port = (argc < 2) ? 9900 : atoi(argv[1]);
	if (conn_open(&con, host, port) < 0) {
		exit(-1);
	}

	memset(sbuf, 0, sizeof(sbuf));
	strcpy(sbuf, "Hello World!");
	rc = conn_write(&con, sbuf, sizeof(sbuf));
	if (rc < 0) {
		printf("error while writing to connection.\n");
		exit(-1);
	}
	memset(rbuf, 0, sizeof(rbuf));
	rc = conn_read(&con, rbuf, sizeof(rbuf));
	if (rc != sizeof(rbuf)) {
		printf("error while reading from connection.\n");
		exit(-1);
	}
	if (memcmp(sbuf, rbuf, sizeof(sbuf)) != 0) {
		printf("error: send and receive buffer not the same!\n");
		exit(-1);
	}
	printf("send: [%s]\n", sbuf);
	printf("recv: [%s]\n", rbuf);

	conn_close(&con);
	return 0;
}

