#ifndef __CONN__H__
#define __CONN__H__

#if defined(__linux__)
#include <netinet/in.h>
#include <sys/un.h>
#include <sys/time.h>
#elif defined(__CYGWIN__)
#include <netinet/in.h>
#endif


#include <stdint.h>

typedef struct server_t {
	int sock;
	struct sockaddr_in addr;
} server_t;

void server_clear(server_t *);
void server_clear_all(server_t *, const int);
void server_close(server_t *);
void server_close_all(server_t *, const int);
int server_open(server_t *, long, short);

typedef struct conn_t {
	int sock;
	struct sockaddr_in addr;  /* address of the server (remote) host */
	struct sockaddr_in local; /* address on the local host */
} conn_t;

void conn_clear(conn_t *);
void conn_close(conn_t *);
int conn_open(conn_t *, long, short);
int conn_accept(server_t *, conn_t *);
void conn_clear_all(conn_t *, const int);
void conn_close_all(conn_t *, const int);
int conn_add(conn_t *, const int, conn_t *);
int conn_close_del(conn_t *, const int, conn_t *);
int conn_wait_to_read(conn_t *, struct timeval *);
int conn_write(conn_t *, const void *, int);
int conn_read(conn_t *, void *, int);

#endif
