#ifndef __GAME__H__
#define __GAME__H__

#include <stdint.h>

enum { FIELD_N = 16 };
enum { MAX_PLAYERS = 4 };

typedef int32_t player_t;

typedef struct field_t {
	player_t data[FIELD_N][FIELD_N];
} field_t;

void field_init(field_t *);

typedef struct coord_t {
	int32_t x;
	int32_t y;
} coord_t;

void coord_init(coord_t *);

typedef struct move_t {
	coord_t from;
	coord_t to;
} move_t;

typedef struct state_t {
	field_t field;
} state_t;

void state_init(state_t *);
player_t state_get(state_t *, int32_t, int32_t);
player_t state_get_coord(state_t *, const coord_t *);
void state_set(state_t *, int32_t, int32_t, player_t);
void state_set_coord(state_t *, const coord_t *, player_t);

int state_move_player(state_t *, const coord_t *, const coord_t *, player_t);
int state_remove_player(state_t *, player_t);

#endif

